function Epsilon=mimo_tune(fun,f,Mp,y,vub,vlb,E_handle,ps,ms,qs,order,...
   L_handle,input_delay,dec_M,pd_prime,pds,handle,decade,tune_index)
% This function bring the magnitude of the worse plant, Mp, of the diagonal elements
% to the reqiured Mp.
if strcmp(fun,'mimo1sen') | strcmp(fun,'mimo2sen')
   errordlg('No tuning available for this frequency response');
   n=length(order);
   for i=1:n
      Epsilon{1}(i)=str2num(get(E_handle(i),'String'));
      if strcmp(fun,'mimo2com') | strcmp(fun,'mimo2sen')| strcmp(fun,'mimopartial')
         Epsilon{2}(i)=str2num(get(E_handle(n+i),'String'));
      end
   end
   return
end
global Xwc_ub_w Tune_flag
n=length(order);
if isempty(Tune_flag) | ~any(Tune_flag)
   errordlg(['To tune the Mp of the diagonal elements, some/all of the upper bound of',...
         ' the diagonal elements must be computed first!']);
   for i=1:n
      Epsilon(i)=str2num(get(E_handle(i),'String'));
   end
   return
end
figure(f);
Mp=Mp(find(Tune_flag));
temp1=max(Mp);
for i=1:n
   Epsilon{1}(i)=str2num(get(E_handle(i),'String'));
   if strcmp(fun,'mimo2com') | strcmp(fun,'mimopartial')
      Epsilon{2}(i)=str2num(get(E_handle(n+i),'String'));
      temp=mq_gen(1,1,dec_M(i),1,1,order(i),y);
      [qd{i,i},qdnum{i,i},qdden{i,i}]=qd_mat(pd_prime{i,i},temp,Epsilon{2}(i),10000,y);
      qd{i,i}=strrep(qd{i,i},'e',['e(' num2str(i) ')']);
   end
   if Tune_flag(i)
      temp1=max([temp1 ; Xwc_ub_w{i,i}(:,1)]);
   end
end
y_limit=[min(Mp)-0.1 round(100*(temp1+0.05))/100];
set(L_handle(1),'String',num2str(y_limit(2)));
set(L_handle(2),'String',num2str(y_limit(1)));
temp=axis;
axis([temp(1:2) y_limit]);
count=1;
for i=1:n
   if Tune_flag(i)
      [temp,temp1]=max(Xwc_ub_w{i,i}(:,1));
      xwc(count,:)=Xwc_ub_w{i,i}(temp1,2:end);
      count=count+1;
   end
end
option=optimset('LargeScale','off','Display','off');
if tune_index==1
   solver='tune_solve';
else
   solver='tune_solve1';
end
if strcmp(fun,'mimo1com')
   qds='';
   Epsilon{1}=fsolve(solver,Epsilon{1},option,Epsilon,...
      fun,xwc,Mp,vub,vlb,y,ps,ms,qs,order,input_delay,pds,qds);
   for i=1:n
      set(E_handle(i),'String',num2str(Epsilon{1}(i)));
   end
else
   qds=cell2str(qd);
   if strcmp(fun,'mimopartial')
      Epsilon{2}=fsolve(solver,Epsilon{2},option,Epsilon,...
         fun,xwc,Mp,vub,vlb,y,ps,ms,qs,order,input_delay,pds,qds);
      for i=1:n
         set(E_handle(n+i),'String',num2str(Epsilon{2}(i)));
      end
   else
      Epsilon{1}=fsolve(solver,Epsilon{1},option,Epsilon,...
         fun,xwc,Mp,vub,vlb,y,ps,ms,qs,order,input_delay,pds,qds);
      for i=1:n
         set(E_handle(i),'String',num2str(Epsilon{1}(i)));
      end
   end
end
% Plot the frequency response of the worse case plants
% after the filetr time constant is changed.
for i=1:n
      bg_color=get(handle(n*(i-1)+i),'Backgroundcolor');
      if Tune_flag(i)
         freq=Xwc_ub_w{i,i}(:,2)';
         [temp,temp1]=max(Xwc_ub_w{i,i}(:,1)');
         x=Xwc_ub_w{i,i}(temp1,3:end);
         data{i}=zeros(1,length(freq));
         for k=1:length(freq)
            data{i}(k)=feval(fun,x,y,Epsilon,1,freq(k),...
              ps,ms,qs,order,i,i,input_delay,pds,qds);
         end
      end
end
figure(f);
for i=1:n
   bg_color=get(handle(n*(i-1)+i),'Backgroundcolor');
   if Tune_flag(i)
      g=loglog(Xwc_ub_w{i,i}(:,2),data{i}',':',10.^decade,[Mp(i) Mp(i)],'-.');
      set(g,'color',bg_color);
      h=text(mean(10.^decade)/2,Mp(i),['Mp = ' num2str(Mp(i))]);
      set(h,'color',bg_color,'VerticalAlignment','bottom');
   end
end
temp=(y_limit(2)-1)/10;
h=text(10.^decade(1)*1.2,y_limit(2)-temp,'- - - - - Expected worse case response with the new filter time constants');
set(h,'color',bg_color,'VerticalAlignment','bottom');
h=text(10.^decade(1)*1.2,y_limit(2)-2*temp,'_____ Original upper bounds','Interpreter','none');
set(h,'color',bg_color,'VerticalAlignment','bottom');
Tune_flag=zeros(1,n);