function [T,M]=transform(A)
% function that find a transformation matrix T that transform
% a matrix or cell array (by column switching) A to a matrix M to have all 
% diagonal elements = 0. (M = A*T)
% The A matrix must be re-arangable to have all diagonal element = 0 
% See also sw_col.m and MSFgainM.m

[m,n]=size(A);
if iscell(A) % take care if A is cell array
   temp=zeros(n,n);
   for i=1:n
      for j=1:n
         temp(i,j)=A{i,j};
      end
   end
A=temp;   
end
A=[A;eye(n)];
sorx=A;
while ~isempty(A)
for i=1:n
   temp=find(A(i,:)==0);
   if length(temp)==1
      sorx(:,i)=A(:,temp);
      A(:,temp)=[];
      break
   end
end
if isempty(temp)
   disp('error! using transform.m, the input matrix is not re-arrangable to have all diagonal elements = 0.');
   break
end
end
M=sorx(1:m,:);
T=sorx(m+1:end,:);